3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 die "$(eval_gettext "remote (\$remote) does not have a url defined in .git/config")"
40 remoteurl=${remoteurl%/}
49 remoteurl="${remoteurl%/*}"
52 remoteurl="${remoteurl%:*}"
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
76 git ls-files --error-unmatch --stage -- "$@" |
79 my ($null_sha1) = ("0" x 40);
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
97 # Map submodule path to submodule name
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
126 if test -n "$reference"
128 git-clone "$reference" -n "$url" "$path"
130 git-clone -n "$url" "$path"
132 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
136 # Add a new submodule to the working tree, .gitmodules and the index
140 # optional branch is stored in global branch variable
144 # parse $args after "submodule ... add".
149 case "$2" in '') usage ;; esac
160 case "$2" in '') usage ;; esac
161 reference="--reference=$2"
185 if test -z "$path"; then
186 path=$(echo "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
190 if test -z "$repo" -o -z "$path"; then
194 # assure repo is absolute or relative to parent
197 # dereference source url relative to parent's url
198 realrepo=$(resolve_relative_url "$repo") || exit
205 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
210 # multiple //; leading ./; /./; /../; trailing /
211 path=$(printf '%s/\n' "$path" |
221 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
222 die "$(eval_gettext "'\$path' already exists in the index")"
224 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
227 eval_gettext "The following path is ignored by one of your .gitignore files:
229 Use -f if you really want to add it." &&
235 # perhaps the path exists and is already a git repo, else clone it
238 if test -d "$path"/.git -o -f "$path"/.git
240 eval_gettext "Adding existing repo at '\$path' to the index"; echo
242 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
247 url=$(resolve_relative_url "$repo") || exit
255 module_clone "$path" "$realrepo" "$reference" || exit
259 # ash fails to wordsplit ${branch:+-b "$branch"...}
261 '') git checkout -f -q ;;
262 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
264 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
266 git config submodule."$path".url "$url"
268 git add $force "$path" ||
269 die "$(eval_gettext "Failed to add submodule '\$path'")"
271 git config -f .gitmodules submodule."$path".path "$path" &&
272 git config -f .gitmodules submodule."$path".url "$repo" &&
273 git add --force .gitmodules ||
274 die "$(eval_gettext "Failed to register submodule '\$path'")"
278 # Execute an arbitrary command sequence in each checked out
281 # $@ = command to execute
285 # parse $args after "submodule ... foreach".
307 # dup stdin so that it can be restored when running the external
308 # command in the subshell (and a recursive call to this function)
312 while read mode sha1 stage path
314 if test -e "$path"/.git
316 say "$(eval_gettext "Entering '\$prefix\$path'")"
317 name=$(module_name "$path")
319 prefix="$prefix$path/"
323 if test -n "$recursive"
325 cmd_foreach "--recursive" "$@"
328 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
334 # Register submodules in .git/config
336 # $@ = requested paths (default to all)
340 # parse $args after "submodule ... init".
362 while read mode sha1 stage path
364 # Skip already registered paths
365 name=$(module_name "$path") || exit
366 if test -z "$(git config "submodule.$name.url")"
368 url=$(git config -f .gitmodules submodule."$name".url)
370 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
372 # Possibly a url relative to parent
375 url=$(resolve_relative_url "$url") || exit
378 git config submodule."$name".url "$url" ||
379 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
382 # Copy "update" setting when it is not set yet
383 upd="$(git config -f .gitmodules submodule."$name".update)"
385 test -n "$(git config submodule."$name".update)" ||
386 git config submodule."$name".update "$upd" ||
387 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
389 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
394 # Update each submodule path to correct revision, using clone and checkout as needed
396 # $@ = requested paths (default to all)
400 # parse $args after "submodule ... update".
421 case "$2" in '') usage ;; esac
422 reference="--reference=$2"
423 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
446 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
452 cmd_init "--" "$@" || return
458 while read mode sha1 stage path
462 echo >&2 "Skipping unmerged submodule $path"
465 name=$(module_name "$path") || exit
466 url=$(git config submodule."$name".url)
467 update_module=$(git config submodule."$name".update)
470 # Only mention uninitialized submodules when its
471 # path have been specified
473 say "$(eval_gettext "Submodule path '\$path' not initialized
474 Maybe you want to use 'update --init'?")"
478 if ! test -d "$path"/.git -o -f "$path"/.git
480 module_clone "$path" "$url" "$reference"|| exit
481 cloned_modules="$cloned_modules;$name"
484 subsha1=$(clear_local_git_env; cd "$path" &&
485 git rev-parse --verify HEAD) ||
486 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
489 if ! test -z "$update"
491 update_module=$update
494 if test "$subsha1" != "$sha1"
497 # If we don't already have a -f flag and the submodule has never been checked out
498 if test -z "$subsha1" -a -z "$force"
503 if test -z "$nofetch"
505 # Run fetch only if $sha1 isn't present or it
506 # is not reachable from a ref.
507 (clear_local_git_env; cd "$path" &&
508 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
509 test -z "$rev") || git-fetch)) ||
510 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
513 # Is this something we just cloned?
514 case ";$cloned_modules;" in
516 # then there is no local change to integrate
521 case "$update_module" in
524 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
525 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
526 must_die_on_failure=yes
530 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
531 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
532 must_die_on_failure=yes
535 command="git checkout $subforce -q"
536 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
537 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
541 if (clear_local_git_env; cd "$path" && $command "$sha1")
544 elif test -n "$must_die_on_failure"
546 die_with_status 2 "$die_msg"
548 err="${err};$die_msg"
553 if test -n "$recursive"
555 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
559 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
562 err="${err};$die_msg"
565 die_with_status $res "$die_msg"
592 git describe "$2" 2>/dev/null ||
593 git describe --tags "$2" 2>/dev/null ||
594 git describe --contains "$2" 2>/dev/null ||
595 git describe --all --always "$2"
598 test -z "$revname" || revname=" ($revname)"
601 # Show commit summary for submodules in index or working tree
603 # If '--cached' is given, show summary between index and given commit,
604 # or between working tree and given commit
606 # $@ = [commit (default 'HEAD'),] requested paths (default all)
613 # parse $args after "submodule ... summary".
627 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
649 test $summary_limit = 0 && return
651 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
655 elif test -z "$1" -o "$1" = "HEAD"
657 # before the first commit: compare with an empty tree
658 head=$(git hash-object -w -t tree --stdin </dev/null)
659 test -z "$1" || shift
667 die "$(gettext -- "--cached cannot be used with --files")"
673 # Get modified modules cared by user
674 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
675 sane_egrep '^:([0-7]* )?160000' |
676 while read mod_src mod_dst sha1_src sha1_dst status name
678 # Always show modules deleted or type-changed (blob<->module)
679 test $status = D -o $status = T && echo "$name" && continue
680 # Also show added or modified modules which are checked out
681 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
686 test -z "$modules" && return
688 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
689 sane_egrep '^:([0-7]* )?160000' |
691 while read mod_src mod_dst sha1_src sha1_dst status name
693 if test -z "$cached" &&
694 test $sha1_dst = 0000000000000000000000000000000000000000
698 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
700 100644 | 100755 | 120000)
701 sha1_dst=$(git hash-object $name)
708 eval_gettext "unexpected mode \$mod_dst" &&
717 test $mod_src = 160000 &&
718 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
721 test $mod_dst = 160000 &&
722 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
726 case "$missing_src,$missing_dst" in
728 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
731 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
734 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
739 if test $mod_src = 160000 -a $mod_dst = 160000
741 range="$sha1_src...$sha1_dst"
742 elif test $mod_src = 160000
748 GIT_DIR="$name/.git" \
749 git rev-list --first-parent $range -- | wc -l
751 total_commits=" ($(($total_commits + 0)))"
755 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
756 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
759 blob="$(gettext "blob")"
760 submodule="$(gettext "submodule")"
761 if test $mod_dst = 160000
763 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
765 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
768 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
772 # Don't give error msg for modification whose dst is not submodule
773 # i.e. deleted or changed to blob
774 test $mod_dst = 160000 && echo "$errmsg"
776 if test $mod_src = 160000 -a $mod_dst = 160000
779 test $summary_limit -gt 0 && limit="-$summary_limit"
780 GIT_DIR="$name/.git" \
781 git log $limit --pretty='format: %m %s' \
782 --first-parent $sha1_src...$sha1_dst
783 elif test $mod_dst = 160000
785 GIT_DIR="$name/.git" \
786 git log --pretty='format: > %s' -1 $sha1_dst
788 GIT_DIR="$name/.git" \
789 git log --pretty='format: < %s' -1 $sha1_src
795 if test -n "$for_status"; then
796 if [ -n "$files" ]; then
797 gettext "# Submodules changed but not updated:"; echo
799 gettext "# Submodule changes to be committed:"; echo
802 sed -e 's|^|# |' -e 's|^# $|#|'
808 # List all submodules, prefixed with:
809 # - submodule not initialized
810 # + different revision checked out
812 # If --cached was specified the revision in the index will be printed
813 # instead of the currently checked out revision.
815 # $@ = requested paths (default to all)
819 # parse $args after "submodule ... status".
844 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
849 while read mode sha1 stage path
851 name=$(module_name "$path") || exit
852 url=$(git config submodule."$name".url)
853 displaypath="$prefix$path"
856 say "U$sha1 $displaypath"
859 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
861 say "-$sha1 $displaypath"
864 set_name_rev "$path" "$sha1"
865 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
867 say " $sha1 $displaypath$revname"
871 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
872 set_name_rev "$path" "$sha1"
874 say "+$sha1 $displaypath$revname"
877 if test -n "$recursive"
880 prefix="$displaypath/"
883 eval cmd_status "$orig_args"
885 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
890 # Sync remote urls for submodules
891 # This makes the value for remote.$remote.url match the value
892 # specified in .gitmodules.
917 while read mode sha1 stage path
919 name=$(module_name "$path")
920 url=$(git config -f .gitmodules --get submodule."$name".url)
922 # Possibly a url relative to parent
925 url=$(resolve_relative_url "$url") || exit
929 if git config "submodule.$name.url" >/dev/null 2>/dev/null
931 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
932 git config submodule."$name".url "$url"
934 if test -e "$path"/.git
939 remote=$(get_default_remote)
940 git config remote."$remote".url "$url"
947 # This loop parses the command line arguments to find the
948 # subcommand name to dispatch. Parsing of the subcommand specific
949 # options are primarily done by the subcommand implementations.
950 # Subcommand specific options such as --branch and --cached are
951 # parsed here as well, for backward compatibility.
953 while test $# != 0 && test -z "$command"
956 add | foreach | init | update | status | summary | sync)
986 # No command word defaults to "status"
987 test -n "$command" || command=status
989 # "-b branch" is accepted only by "add"
990 if test -n "$branch" && test "$command" != add
995 # "--cached" is accepted only by "status" and "summary"
996 if test -n "$cached" && test "$command" != status -a "$command" != summary